'use strict';

var stream = require('stream');

var split = function split(substr) {
  var matchBy = new RegExp(substr);
  return Object.assign(new stream.Transform({
    transform: function transform(chunk, encoding, callback) {
      var str = chunk.toString();
      var startOfOutput = str.match(matchBy);
      if (startOfOutput) {
        this.strBuffer = this.strBuffer + str.slice(0, startOfOutput.index);
        this.push(this.strBuffer);
        this.strBuffer = str.slice(startOfOutput.index);
        callback();
      } else {
        this.strBuffer = this.strBuffer + str;
        callback();
      }
    },
    flush: function flush(callback) {
      this.push(this.strBuffer);
      this.strBuffer = '';
      callback();
    }
  }), { strBuffer: '' });
};

module.exports = split;