'use strict';

var spawn = require('child_process').spawn;

var defaultOptions = {
  delay: 1,
  samples: 0,
  args: ''
};

var top = function top(opts) {
  var options = Object.assign(defaultOptions, opts);

  var instance = spawn('top', ('-l ' + options.samples + ' -s ' + options.delay + ' ' + options.args).trim().split(' '));

  process.on('uncaughtException', function (err) {
    instance.kill();
    console.error(err);
  });

  return instance;
};

module.exports = top;